package com.alvin;

import picocli.CommandLine;

@CommandLine.Command(name = "export", mixinStandardHelpOptions = true, helpCommand = true)
    public class ExportCmd {
        @CommandLine.Option(names = {"-r", "--jdbc-url"}, required = true, description = "数据库地址")
        public String jdbcUrl;
        @CommandLine.Option(names = {"-u", "--username"}, required = true, description = "用户名")
        public String username;
        @CommandLine.Option(names = {"-p", "--secret-key"}, required = true, description = "秘钥")
        public String secretKey;
        @CommandLine.Option(names = {"-d", "--database"}, defaultValue = "default", description = "库名，默认为default")
        public String database;
        @CommandLine.Option(names = {"-t", "--table"}, description = "表名，多个表用逗号分开")
        public String tables;
    }